#!/usr/bin/env python
# -*- coding: utf-8 -*-

# # HDInsight, PIG
# 
# Short examples on how to connect to a cluster from a notebook and submit a job (Azure + PIG).

# In[1]:


from jyquickhelper import add_notebook_menu
add_notebook_menu()


# ## Download the data

# In[2]:


url = "https://archive.ics.uci.edu/ml/machine-learning-databases/00222/"
file = "bank.zip"
import pyensae
data = pyensae.download_data(file, website=url)


# In[3]:


import pandas
df = pandas.read_csv("bank-full.csv", sep=";")


# In[4]:


df.head()


# In[5]:


df.to_csv("bank_full_tab_no.txt", sep="\t", index=False, header=None)


# ## Connect to the cluster

# In[6]:


import pyensae
blobstorage = 
blobpassword = 
hadoop_server = 
hadoop_password = 
username = "centrale"
client, bs =  get_ipython().run_line_magic('hd_open', '')
client, bs


# ## Upload the data

# In[7]:


get_ipython().run_line_magic('blob_up', 'bank_full_tab_no.txt hdblobstorage/centrale2/bank_full_tab_no.txt')


# In[8]:


get_ipython().run_line_magic('blob_ls', 'hdblobstorage/centrale2')


# ## Submit a PIG query

# In[9]:


mapping = {'int64': 'double', 'float': 'double', 'object': 'chararray'}
schema = ["%s:%s" % (_[0], mapping.get(str(_[1]), _[1])) for _ in zip(df.columns, df.dtypes)]
schema = ", ".join(schema)
schema


# On ajoute l'instruction [DESCRIBE](http://pig.apache.org/docs/r0.16.0/test.html#describe).

# In[10]:


get_ipython().run_cell_magic('PIG_azure', 'aggage3.pig', "values = LOAD '$CONTAINER/centrale/bank_full_tab_no.txt' USING PigStorage('\\t') AS (age:double, \n                    job:chararray, marital:chararray, education:chararray, \n                   default:chararray, balance:double, housing:chararray, loan:chararray, \n                   contact:chararray, day:double, month:chararray, duration:double, \n                   campaign:double, pdays:double, previous:double, poutcome:chararray, y:chararray);\nDESCRIBE values;\ngr = GROUP values BY loan ;\nDESCRIBE gr;\nagg = FOREACH gr GENERATE group, AVG(age) AS avg_age ;\nDESCRIBE agg;\nSTORE agg INTO '$CONTAINER/centrale/bank_full_tab_no_agg.txt' USING PigStorage('\\t') ;\n")


# In[11]:


jid = get_ipython().run_line_magic('hd_pig_submit', 'aggage3.pig')


# In[12]:


jid


# In[13]:


get_ipython().run_line_magic('hd_queue', '')


# In[14]:


df = get_ipython().run_line_magic('hd_job_status', "jid['id']")
df["status"]["state"]


# In[15]:


get_ipython().run_line_magic('hd_tail_stderr', "-n 100 jid['id']")


# In[16]:


get_ipython().run_cell_magic('PIG_azure', 'aggage4.pig', "values = LOAD '$CONTAINER/centrale/bank_full_tab_no.txt' USING PigStorage('\\t') AS (age:double, \n                                                    job:chararray, marital:chararray, education:chararray, \n                                                   default:chararray, balance:double, housing:chararray, loan:chararray, \n                                                   contact:chararray, day:double, month:chararray, duration:double, \n                                                   campaign:double, \n                                                   pdays:double, previous:double, poutcome:chararray, y:chararray);\nDESCRIBE values;\ngr = GROUP values BY loan ;\nDESCRIBE gr;\nagg = FOREACH gr GENERATE group, AVG(values.age) AS avg_age ;\nDESCRIBE agg;\nSTORE agg INTO '$CONTAINER/centrale/bank_full_tab_no_agg2.txt' USING PigStorage('\\t') ;\n")


# In[17]:


jid = get_ipython().run_line_magic('hd_pig_submit', 'aggage4.pig')


# In[18]:


jid


# In[19]:


get_ipython().run_line_magic('hd_queue', '')


# In[20]:


df = get_ipython().run_line_magic('hd_job_status', "jid['id']")
df["status"]["state"]


# In[21]:


hd_tail_stderr -n 50 jid['id']


# In[22]:


get_ipython().run_line_magic('blob_ls', '/centrale')


# In[23]:


get_ipython().run_line_magic('blob_downmerge', '--help')


# In[24]:


get_ipython().run_line_magic('blob_down', '/centrale/bank_full_tab_no_agg2.txt/part-r-00000 agg_hadoop3.txt')


# In[25]:


import pandas
df = pandas.read_csv("agg_hadoop3.txt", sep="\t", header=-1)
df


# J'ai oublié d'enlever le header. On vérifie que les calcus sont bons en les faisant en local.

# In[26]:


df = pandas.read_csv("bank-full.csv", sep=";")
df.head()


# In[27]:


df[["loan", "age"]].groupby("loan").mean()


# In[28]: